#include "ansitbl.h"

int atGroundTable[]=
{
/*	NUL		SOH		STX		ETX	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	EOT		ENQ		ACK		BEL	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_BELL,
/*	BS		HT		LF		VT	*/
ATSTATE_BS,
ATSTATE_HT,
ATSTATE_VT,
ATSTATE_VT,
/*	NP		CR		SO		SI	*/
ATSTATE_VT,
ATSTATE_CR,
ATSTATE_SO,
ATSTATE_SI,
/*	DLE		DC1		DC2		DC3	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	DC4		NAK		SYN		ETB	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	CAN		EM		SUB		ESC	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_ESC,
/*	FS		GS		RS		US	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	SP		!		"		#	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	$		%		&		'	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	(		)		*		+	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	,		-		.		/	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	0		1		2		3	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	4		5		6		7	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	8		9		:		;	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	<		=		>		?	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT, 
/*	@		A		B		C	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	D		E		F		G	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	H		I		J		K	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	L		M		N		O	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	P		Q		R		S	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	T		U		V		W	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	X		Y		Z		[	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	\		]		^		_	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	`		a		b		c	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	d		e		f		g	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	h		i		j		k	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	l		m		n		o	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	p		q		r		s	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	t		u		v		w	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	x		y		z		{	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*	|		}		~		DEL	*/
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_DEL,
/*      0x80            0x81            0x82            0x83    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x84            0x85            0x86            0x87    */
ATSTATE_IGNORE,
ATSTATE_NEL,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x88            0x89            0x8a            0x8b    */
ATSTATE_HTS,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x8c            0x8d            0x8e            0x8f    */
ATSTATE_IGNORE,
ATSTATE_RI,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x90            0x91            0x92            0x93    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x94            0x95            0x96            0x97    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x99            0x99            0x9a            0x9b    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_CSI_STATE,
/*      0x9c            0x9d            0x9e            0x9f    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      nobreakspace    exclamdown      cent            sterling        */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      currency        yen             brokenbar       section         */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      diaeresis       copyright       ordfeminine     guillemotleft   */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      notsign         hyphen          registered      macron          */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      degree          plusminus       twosuperior     threesuperior   */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      acute           mu              paragraph       periodcentered  */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      cedilla         onesuperior     masculine       guillemotright  */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      onequarter      onehalf         threequarters   questiondown    */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      Agrave          Aacute          Acircumflex     Atilde          */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      Adiaeresis      Aring           AE              Ccedilla        */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      Igrave          Iacute          Icircumflex     Idiaeresis      */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      Eth             Ntilde          Ograve          Oacute          */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      Ocircumflex     Otilde          Odiaeresis      multiply        */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      Ooblique        Ugrave          Uacute          Ucircumflex     */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      Udiaeresis      Yacute          Thorn           ssharp          */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      agrave          aacute          acircumflex     atilde          */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      adiaeresis      aring           ae              ccedilla        */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      egrave          eacute          ecircumflex     ediaeresis      */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      igrave          iacute          icircumflex     idiaeresis      */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      eth             ntilde          ograve          oacute          */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_IGNORE,
ATSTATE_PRINT,
/*      ocircumflex     otilde          odiaeresis      division        */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      oslash          ugrave          uacute          ucircumflex     */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
/*      udiaeresis      yacute          thorn           ydiaeresis      */
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
ATSTATE_PRINT,
};

int atCSITable[] =		/* ESC [ */
{
/*	NUL		SOH		STX		ETX	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	EOT		ENQ		ACK		BEL	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_BELL,
/*	BS		HT		NL		VT	*/
ATSTATE_BS,
ATSTATE_HT,
ATSTATE_VT,
ATSTATE_VT,
/*	NP		CR		SO		SI	*/
ATSTATE_VT,
ATSTATE_CR,
ATSTATE_SO,
ATSTATE_SI,
/*	DLE		DC1		DC2		DC3	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	DC4		NAK		SYN		ETB	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	CAN		EM		SUB		ESC	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_ESC,
/*	FS		GS		RS		US	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	SP		!		"		#	*/
ATSTATE_CSI_SIB,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
/*	$		%		&		'	*/
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
/*	(		)		*		+	*/
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
/*	,		-		.		/	*/
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
/*	0		1		2		3	*/
ATSTATE_ESC_DIGIT,
ATSTATE_ESC_DIGIT,
ATSTATE_ESC_DIGIT,
ATSTATE_ESC_DIGIT,
/*	4		5		6		7	*/
ATSTATE_ESC_DIGIT,
ATSTATE_ESC_DIGIT,
ATSTATE_ESC_DIGIT,
ATSTATE_ESC_DIGIT,
/*	8		9		:		;	*/
ATSTATE_ESC_DIGIT,
ATSTATE_ESC_DIGIT,
ATSTATE_IGNORE,
ATSTATE_ESC_SEMI,
/*	<		=		>		?	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	@		A		B		C	*/
ATSTATE_ICH,
ATSTATE_CUU,
ATSTATE_CUD,
ATSTATE_CUF,
/*	D		E		F		G	*/
ATSTATE_CUB,
ATSTATE_CNL,
ATSTATE_CPL,
ATSTATE_CHA,
/*	H		I		J		K	*/
ATSTATE_CUP,
ATSTATE_CHT,
ATSTATE_ED,
ATSTATE_EL,
/*	L		M		N		O	*/
ATSTATE_IL,
ATSTATE_DL,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	P		Q		R		S	*/
ATSTATE_DCH,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_SU,
/*	T		U		V		W	*/
ATSTATE_SD,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_CTC,
/*	X		Y		Z		[	*/
ATSTATE_ECH,
ATSTATE_GROUND_STATE,
ATSTATE_CBT,
ATSTATE_GROUND_STATE,
/*	\		]		^		_	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_SIMD,
ATSTATE_GROUND_STATE,
/*	`		a		b		c	*/
ATSTATE_CHA,
ATSTATE_CUF,
ATSTATE_GROUND_STATE,
ATSTATE_DA1,
/*	d		e		f		g	*/
ATSTATE_VPA,
ATSTATE_CUD,
ATSTATE_CUP,
ATSTATE_TBC,
/*	h		i		j		k	*/
ATSTATE_SET,
ATSTATE_GROUND_STATE,
ATSTATE_CUB,
ATSTATE_CUU,
/*	l		m		n		o	*/
ATSTATE_RST,
ATSTATE_SGR,
ATSTATE_CPR,
ATSTATE_GROUND_STATE,
/*	p		q		r		s	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_DECSTBM,
ATSTATE_GROUND_STATE,
/*	t		u		v		w	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	x		y		z		{	*/
ATSTATE_DECREQTPARM,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	|		}		~		DEL	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      0x80            0x81            0x82            0x83    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x84            0x85            0x86            0x87    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x88            0x89            0x8a            0x8b    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x8c            0x8d            0x8e            0x8f    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x90            0x91            0x92            0x93    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x94            0x95            0x96            0x97    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x99            0x99            0x9a            0x9b    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x9c            0x9d            0x9e            0x9f    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      nobreakspace    exclamdown      cent            sterling        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      currency        yen             brokenbar       section         */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      diaeresis       copyright       ordfeminine     guillemotleft   */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      notsign         hyphen          registered      macron          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      degree          plusminus       twosuperior     threesuperior   */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      acute           mu              paragraph       periodcentered  */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      cedilla         onesuperior     masculine       guillemotright  */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      onequarter      onehalf         threequarters   questiondown    */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Agrave          Aacute          Acircumflex     Atilde          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Adiaeresis      Aring           AE              Ccedilla        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Igrave          Iacute          Icircumflex     Idiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Eth             Ntilde          Ograve          Oacute          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Ocircumflex     Otilde          Odiaeresis      multiply        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Ooblique        Ugrave          Uacute          Ucircumflex     */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Udiaeresis      Yacute          Thorn           ssharp          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      agrave          aacute          acircumflex     atilde          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      adiaeresis      aring           ae              ccedilla        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      egrave          eacute          ecircumflex     ediaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      igrave          iacute          icircumflex     idiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      eth             ntilde          ograve          oacute          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      ocircumflex     otilde          odiaeresis      division        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      oslash          ugrave          uacute          ucircumflex     */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      udiaeresis      yacute          thorn           ydiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
};

int atEIGTable[] =		/* ATSTATE_ESC_IGNORE */
{
/*	NUL		SOH		STX		ETX	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	EOT		ENQ		ACK		BEL	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_BELL,
/*	BS		HT		NL		VT	*/
ATSTATE_BS,
ATSTATE_HT,
ATSTATE_VT,
ATSTATE_VT,
/*	NP		CR		SO		SI	*/
ATSTATE_VT,
ATSTATE_CR,
ATSTATE_SO,
ATSTATE_SI,
/*	DLE		DC1		DC2		DC3	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	DC4		NAK		SYN		ETB	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	CAN		EM		SUB		ESC	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_ESC,
/*	FS		GS		RS		US	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	SP		!		"		#	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	$		%		&		'	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	(		)		*		+	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	,
	-		.		/	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	0		1		2		3	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	4		5		6		7	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	8		9		:		;	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	<		=		>		?	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	@		A		B		C	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	D		E		F		G	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	H		I		J		K	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	L		M		N		O	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	P		Q		R		S	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	T		U		V		W	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	X		Y		Z		[	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	\		]		^		_	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	`		a		b		c	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	d		e		f		g	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	h		i		j		k	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	l		m		n		o	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	p		q		r		s	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	t		u		v		w	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	x		y		z		{	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	|		}		~		DEL	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      0x80            0x81            0x82            0x83    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x84            0x85            0x86            0x87    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x88            0x89            0x8a            0x8b    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x8c            0x8d            0x8e            0x8f    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x90            0x91            0x92            0x93    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x94            0x95            0x96            0x97    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x99            0x99            0x9a            0x9b    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x9c            0x9d            0x9e            0x9f    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      nobreakspace    exclamdown      cent            sterling        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      currency        yen             brokenbar       section         */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      diaeresis       copyright       ordfeminine     guillemotleft   */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      notsign         hyphen          registered      macron          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      degree          plusminus       twosuperior     threesuperior   */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      acute           mu              paragraph       periodcentered  */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      cedilla         onesuperior     masculine       guillemotright  */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      onequarter      onehalf         threequarters   questiondown    */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Agrave          Aacute          Acircumflex     Atilde          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Adiaeresis      Aring           AE              Ccedilla        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Igrave          Iacute          Icircumflex     Idiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Eth             Ntilde          Ograve          Oacute          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Ocircumflex     Otilde          Odiaeresis      multiply        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Ooblique        Ugrave          Uacute          Ucircumflex     */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Udiaeresis      Yacute          Thorn           ssharp          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      agrave          aacute          acircumflex     atilde          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      adiaeresis      aring           ae              ccedilla        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      egrave          eacute          ecircumflex     ediaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      igrave          iacute          icircumflex     idiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      eth             ntilde          ograve          oacute          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      ocircumflex     otilde          odiaeresis      division        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      oslash          ugrave          uacute          ucircumflex     */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      udiaeresis      yacute          thorn           ydiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
};

int atESCTable[] =		/* ESC */
{
/*	NUL		SOH		STX		ETX	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	EOT		ENQ		ACK		BEL	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_BELL,
/*	BS		HT		NL		VT	*/
ATSTATE_BS,
ATSTATE_HT,
ATSTATE_VT,
ATSTATE_VT,
/*	NP		CR		SO		SI	*/
ATSTATE_VT,
ATSTATE_CR,
ATSTATE_SO,
ATSTATE_SI,
/*	DLE		DC1		DC2		DC3	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	DC4		NAK		SYN		ETB	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	CAN		EM		SUB		ESC	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_ESC,
/*	FS		GS		RS		US	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	SP		!		"		#	*/
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_SCR_STATE,
/*	$		%		&		'	*/
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
/*	(		)		*		+	*/
ATSTATE_SCS0_STATE,
ATSTATE_SCS1_STATE,
ATSTATE_SCS2_STATE,
ATSTATE_SCS3_STATE,
/*	,		-		.		/	*/
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
/*	0		1		2		3	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	4		5		6		7	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_DECSC,
/*	8		9		:		;	*/
ATSTATE_DECRC,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	<		=		>		?	*/
ATSTATE_GROUND_STATE,
ATSTATE_DECKPAM,
ATSTATE_DECKPNM,
ATSTATE_GROUND_STATE,
/*	@		A		B		C	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	D		E		F		G	*/
ATSTATE_IND,
ATSTATE_NEL,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	H		I		J		K	*/
ATSTATE_HTS,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	L		M		N		O	*/
ATSTATE_GROUND_STATE,
ATSTATE_RI,
ATSTATE_SS2,
ATSTATE_SS3,
/*	P		Q		R		S	*/
ATSTATE_IGNORE_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	T		U		V		W	*/
ATSTATE_XTERM_TITLE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	X		Y		Z		[	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_CSI_STATE,
/*	\		]		^		_	*/
ATSTATE_GROUND_STATE,
ATSTATE_OSC,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	`		a		b		c	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_RIS,
/*	d		e		f		g	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	h		i		j		k	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	l		m		n		o	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_LS2,
ATSTATE_LS3,
/*	p		q		r		s	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	t		u		v		w	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	x		y		z		{	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	|		}		~		DEL	*/
ATSTATE_LS3R,
ATSTATE_LS2R,
ATSTATE_LS1R,
ATSTATE_GROUND_STATE,
/*      0x80            0x81            0x82            0x83    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x84            0x85            0x86            0x87    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x88            0x89            0x8a            0x8b    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x8c            0x8d            0x8e            0x8f    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x90            0x91            0x92            0x93    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x94            0x95            0x96            0x97    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x99            0x99            0x9a            0x9b    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x9c            0x9d            0x9e            0x9f    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      nobreakspace    exclamdown      cent            sterling        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      currency        yen             brokenbar       section         */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      diaeresis       copyright       ordfeminine     guillemotleft   */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      notsign         hyphen          registered      macron          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      degree          plusminus       twosuperior     threesuperior   */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      acute           mu              paragraph       periodcentered  */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      cedilla         onesuperior     masculine       guillemotright  */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      onequarter      onehalf         threequarters   questiondown    */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Agrave          Aacute          Acircumflex     Atilde          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Adiaeresis      Aring           AE              Ccedilla        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Igrave          Iacute          Icircumflex     Idiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Eth             Ntilde          Ograve          Oacute          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Ocircumflex     Otilde          Odiaeresis      multiply        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Ooblique        Ugrave          Uacute          Ucircumflex     */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Udiaeresis      Yacute          Thorn           ssharp          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      agrave          aacute          acircumflex     atilde          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      adiaeresis      aring           ae              ccedilla        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      egrave          eacute          ecircumflex     ediaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      igrave          iacute          icircumflex     idiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      eth             ntilde          ograve          oacute          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      ocircumflex     otilde          odiaeresis      division        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      oslash          ugrave          uacute          ucircumflex     */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      udiaeresis      yacute          thorn           ydiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
};

int atIESTable[] =		/* ATSTATE_IGNORE_ESC */
{
/*	NUL		SOH		STX		ETX	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	EOT		ENQ		ACK		BEL	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	BS		HT		NL		VT	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	NP		CR		SO		SI	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	DLE		DC1		DC2		DC3	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	DC4		NAK		SYN		ETB	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	CAN		EM		SUB		ESC	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	FS		GS		RS		US	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	SP		!		"		#	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	$		%		&		'	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	(		)		*		+	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	,		-		.		/	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	0		1		2		3	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	4		5		6		7	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	8		9		:		;	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	<		=		>		?	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	@		A		B		C	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	D		E		F		G	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	H		I		J		K	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	L		M		N		O	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	P		Q		R		S	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	T		U		V		W	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	X		Y		Z		[	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	\		]		^		_	*/
ATSTATE_GROUND_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	`		a		b		c	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	d		e		f		g	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	h		i		j		k	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	l		m		n		o	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	p		q		r		s	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	t		u		v		w	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	x		y		z		{	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*	|		}		~		DEL	*/
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
ATSTATE_IGNORE_STATE,
/*      0x80            0x81            0x82            0x83    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x84            0x85            0x86            0x87    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x88            0x89            0x8a            0x8b    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x8c            0x8d            0x8e            0x8f    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x90            0x91            0x92            0x93    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x94            0x95            0x96            0x97    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x99            0x99            0x9a            0x9b    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x9c            0x9d            0x9e            0x9f    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      nobreakspace    exclamdown      cent            sterling        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      currency        yen             brokenbar       section         */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      diaeresis       copyright       ordfeminine     guillemotleft   */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      notsign         hyphen          registered      macron          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      degree          plusminus       twosuperior     threesuperior   */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      acute           mu              paragraph       periodcentered  */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      cedilla         onesuperior     masculine       guillemotright  */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      onequarter      onehalf         threequarters   questiondown    */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Agrave          Aacute          Acircumflex     Atilde          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Adiaeresis      Aring           AE              Ccedilla        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Igrave          Iacute          Icircumflex     Idiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Eth             Ntilde          Ograve          Oacute          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Ocircumflex     Otilde          Odiaeresis      multiply        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Ooblique        Ugrave          Uacute          Ucircumflex     */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Udiaeresis      Yacute          Thorn           ssharp          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      agrave          aacute          acircumflex     atilde          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      adiaeresis      aring           ae              ccedilla        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      egrave          eacute          ecircumflex     ediaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      igrave          iacute          icircumflex     idiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      eth             ntilde          ograve          oacute          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      ocircumflex     otilde          odiaeresis      division        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      oslash          ugrave          uacute          ucircumflex     */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      udiaeresis      yacute          thorn           ydiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
};

int atIGNTable[] =		/* ATSTATE_IGNORE_STATE */
{
/*	NUL		SOH		STX		ETX	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	EOT		ENQ		ACK		BEL	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	BS		HT		NL		VT	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	NP		CR		SO		SI	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	DLE		DC1		DC2		DC3	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	DC4		NAK		SYN		ETB	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	CAN		EM		SUB		ESC	*/
ATSTATE_GROUND_STATE, 
ATSTATE_IGNORE,
ATSTATE_GROUND_STATE,
ATSTATE_IGNORE_ESC,
/*	FS		GS		RS		US	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	SP		!		"		#	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	$		%		&		'	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	(		)		*		+	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	,		-		.		/	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	0		1		2		3	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	4		5		6		7	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	8		9		:		;	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	<		=		>		?	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	@		A		B		C	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	D		E		F		G	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	H		I		J		K	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	L		M		N		O	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	P		Q		R		S	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	T		U		V		W	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	X		Y		Z		[	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	\		]		^		_	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	`		a		b		c	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	d		e		f		g	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	h		i		j		k	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	l		m		n		o	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	p		q		r		s	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	t		u		v		w	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	x		y		z		{	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	|		}		~		DEL	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x80            0x81            0x82            0x83    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x84            0x85            0x86            0x87    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x88            0x89            0x8a            0x8b    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x8c            0x8d            0x8e            0x8f    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x90            0x91            0x92            0x93    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x94            0x95            0x96            0x97    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x99            0x99            0x9a            0x9b    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x9c            0x9d            0x9e            0x9f    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      nobreakspace    exclamdown      cent            sterling        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      currency        yen             brokenbar       section         */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      diaeresis       copyright       ordfeminine     guillemotleft   */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      notsign         hyphen          registered      macron          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      degree          plusminus       twosuperior     threesuperior   */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      acute           mu              paragraph       periodcentered  */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      cedilla         onesuperior     masculine       guillemotright  */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      onequarter      onehalf         threequarters   questiondown    */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Agrave          Aacute          Acircumflex     Atilde          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Adiaeresis      Aring           AE              Ccedilla        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Igrave          Iacute          Icircumflex     Idiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Eth             Ntilde          Ograve          Oacute          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Ocircumflex     Otilde          Odiaeresis      multiply        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Ooblique        Ugrave          Uacute          Ucircumflex     */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Udiaeresis      Yacute          Thorn           ssharp          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      agrave          aacute          acircumflex     atilde          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      adiaeresis      aring           ae              ccedilla        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      egrave          eacute          ecircumflex     ediaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      igrave          iacute          icircumflex     idiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      eth             ntilde          ograve          oacute          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      ocircumflex     otilde          odiaeresis      division        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      oslash          ugrave          uacute          ucircumflex     */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      udiaeresis      yacute          thorn           ydiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
};

int atSCRTable[] =		/* ESC # */
{
/*	NUL		SOH		STX		ETX	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	EOT		ENQ		ACK		BEL	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_BELL,
/*	BS		HT		NL		VT	*/
ATSTATE_BS,
ATSTATE_HT,
ATSTATE_VT,
ATSTATE_VT,
/*	NP		CR		SO		SI	*/
ATSTATE_VT,
ATSTATE_CR,
ATSTATE_SO,
ATSTATE_SI,
/*	DLE		DC1		DC2		DC3	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	DC4		NAK		SYN		ETB	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	CAN		EM		SUB		ESC	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_ESC,
/*	FS		GS		RS		US	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	SP		!		"		#	*/
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
/*	$		%		&		'	*/
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
/*	(		)		*		+	*/
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
/*	,		-		.		/	*/
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
/*	0		1		2		3	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	4		5		6		7	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	8		9		:		;	*/
ATSTATE_DECALN,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	<		=		>		?	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	@		A		B		C	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	D		E		F		G	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	H		I		J		K	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	L		M		N		O	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	P		Q		R		S	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	T		U		V		W	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	X		Y		Z		[	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	\		]		^		_	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	`		a		b		c	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	d		e		f		g	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	h		i		j		k	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	l		m		n		o	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	p		q		r		s	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	t		u		v		w	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	x		y		z		{	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	|		}		~		DEL	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      0x80            0x81            0x82            0x83    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x84            0x85            0x86            0x87    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x88            0x89            0x8a            0x8b    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x8c            0x8d            0x8e            0x8f    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x90            0x91            0x92            0x93    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x94            0x95            0x96            0x97    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x99            0x99            0x9a            0x9b    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x9c            0x9d            0x9e            0x9f    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      nobreakspace    exclamdown      cent            sterling        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      currency        yen             brokenbar       section         */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      diaeresis       copyright       ordfeminine     guillemotleft   */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      notsign         hyphen          registered      macron          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      degree          plusminus       twosuperior     threesuperior   */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      acute           mu              paragraph       periodcentered  */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      cedilla         onesuperior     masculine       guillemotright  */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      onequarter      onehalf         threequarters   questiondown    */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Agrave          Aacute          Acircumflex     Atilde          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Adiaeresis      Aring           AE              Ccedilla        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Igrave          Iacute          Icircumflex     Idiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Eth             Ntilde          Ograve          Oacute          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Ocircumflex     Otilde          Odiaeresis      multiply        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Ooblique        Ugrave          Uacute          Ucircumflex     */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Udiaeresis      Yacute          Thorn           ssharp          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      agrave          aacute          acircumflex     atilde          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      adiaeresis      aring           ae              ccedilla        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      egrave          eacute          ecircumflex     ediaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      igrave          iacute          icircumflex     idiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      eth             ntilde          ograve          oacute          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      ocircumflex     otilde          odiaeresis      division        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      oslash          ugrave          uacute          ucircumflex     */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      udiaeresis      yacute          thorn           ydiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
};

int atSCSTable[] =		/* ESC ( etc. */
{
/*	NUL		SOH		STX		ETX	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	EOT		ENQ		ACK		BEL	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_BELL,
/*	BS		HT		NL		VT	*/
ATSTATE_BS,
ATSTATE_HT,
ATSTATE_VT,
ATSTATE_VT,
/*	NP		CR		SO		SI	*/
ATSTATE_VT,
ATSTATE_CR,
ATSTATE_SO,
ATSTATE_SI,
/*	DLE		DC1		DC2		DC3	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	DC4		NAK		SYN		ETB	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	CAN		EM		SUB		ESC	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_ESC,
/*	FS		GS		RS		US	*/
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*	SP		!		"		#	*/
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
/*	$		%		&		'	*/
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
/*	(		)		*		+	*/
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
/*	,		-		.		/	*/
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
ATSTATE_ESC_IGNORE,
/*	0		1		2		3	*/
ATSTATE_GSETS,
ATSTATE_GSETS,
ATSTATE_GSETS,
ATSTATE_GROUND_STATE,
/*	4		5		6		7	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	8		9		:		;	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	<		=		>		?	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	@		A		B		C	*/
ATSTATE_GROUND_STATE,
ATSTATE_GSETS,
ATSTATE_GSETS,
ATSTATE_GROUND_STATE,
/*	D		E		F		G	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	H		I		J		K	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	L		M		N		O	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	P		Q		R		S	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	T		U		V		W	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	X		Y		Z		[	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	\		]		^		_	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	`		a		b		c	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	d		e		f		g	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	h		i		j		k	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	l		m		n		o	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	p		q		r		s	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	t		u		v		w	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	x		y		z		{	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	|		}		~		DEL	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      0x80            0x81            0x82            0x83    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x84            0x85            0x86            0x87    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x88            0x89            0x8a            0x8b    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x8c            0x8d            0x8e            0x8f    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x90            0x91            0x92            0x93    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x94            0x95            0x96            0x97    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x99            0x99            0x9a            0x9b    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      0x9c            0x9d            0x9e            0x9f    */
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
ATSTATE_IGNORE,
/*      nobreakspace    exclamdown      cent            sterling        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      currency        yen             brokenbar       section         */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      diaeresis       copyright       ordfeminine     guillemotleft   */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      notsign         hyphen          registered      macron          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      degree          plusminus       twosuperior     threesuperior   */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      acute           mu              paragraph       periodcentered  */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      cedilla         onesuperior     masculine       guillemotright  */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      onequarter      onehalf         threequarters   questiondown    */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Agrave          Aacute          Acircumflex     Atilde          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Adiaeresis      Aring           AE              Ccedilla        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Igrave          Iacute          Icircumflex     Idiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Eth             Ntilde          Ograve          Oacute          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Ocircumflex     Otilde          Odiaeresis      multiply        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Ooblique        Ugrave          Uacute          Ucircumflex     */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Udiaeresis      Yacute          Thorn           ssharp          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      agrave          aacute          acircumflex     atilde          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      adiaeresis      aring           ae              ccedilla        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      egrave          eacute          ecircumflex     ediaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      igrave          iacute          icircumflex     idiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      eth             ntilde          ograve          oacute          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      ocircumflex     otilde          odiaeresis      division        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      oslash          ugrave          uacute          ucircumflex     */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      udiaeresis      yacute          thorn           ydiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
};

int atCSI_SIBTable[] =		/* ESC [ */
{
/*	NUL		SOH		STX		ETX	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	EOT		ENQ		ACK		BEL	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	BS		HT		NL		VT	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	NP		CR		SO		SI	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	DLE		DC1		DC2		DC3	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	DC4		NAK		SYN		ETB	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	CAN		EM		SUB		ESC	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	FS		GS		RS		US	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	SP		!		"		#	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	$		%		&		'	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	(		)		*		+	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	,		-		.		/	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	0		1		2		3	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	4		5		6		7	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	8		9		:		;	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	<		=		>		?	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	@		A		B		C	*/
ATSTATE_SL,
ATSTATE_SR,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	D		E		F		G	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	H		I		J		K	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	L		M		N		O	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	P		Q		R		S	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	T		U		V		W	*/
ATSTATE_GROUND_STATE,
ATSTATE_SLH,
ATSTATE_SLL,
ATSTATE_GROUND_STATE,
/*	X		Y		Z		[	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	\		]		^		_	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	`		a		b		c	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	d		e		f		g	*/
ATSTATE_TSR,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	h		i		j		k	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	l		m		n		o	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	p		q		r		s	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	t		u		v		w	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	x		y		z		{	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*	|		}		~		DEL	*/
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      0x80            0x81            0x82            0x83    */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      0x84            0x85            0x86            0x87    */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      0x88            0x89            0x8a            0x8b    */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      0x8c            0x8d            0x8e            0x8f    */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      0x90            0x91            0x92            0x93    */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      0x94            0x95            0x96            0x97    */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      0x99            0x99            0x9a            0x9b    */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      0x9c            0x9d            0x9e            0x9f    */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      nobreakspace    exclamdown      cent            sterling        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      currency        yen             brokenbar       section         */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      diaeresis       copyright       ordfeminine     guillemotleft   */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      notsign         hyphen          registered      macron          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      degree          plusminus       twosuperior     threesuperior   */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      acute           mu              paragraph       periodcentered  */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      cedilla         onesuperior     masculine       guillemotright  */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      onequarter      onehalf         threequarters   questiondown    */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Agrave          Aacute          Acircumflex     Atilde          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Adiaeresis      Aring           AE              Ccedilla        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Igrave          Iacute          Icircumflex     Idiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Eth             Ntilde          Ograve          Oacute          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Ocircumflex     Otilde          Odiaeresis      multiply        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Ooblique        Ugrave          Uacute          Ucircumflex     */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      Udiaeresis      Yacute          Thorn           ssharp          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      agrave          aacute          acircumflex     atilde          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      adiaeresis      aring           ae              ccedilla        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      egrave          eacute          ecircumflex     ediaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      igrave          iacute          icircumflex     idiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      eth             ntilde          ograve          oacute          */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      ocircumflex     otilde          odiaeresis      division        */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      oslash          ugrave          uacute          ucircumflex     */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
/*      udiaeresis      yacute          thorn           ydiaeresis      */
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
ATSTATE_GROUND_STATE,
};

char *atStateTable[] = {
  "ATSTATE_GROUND_STATE",
  "ATSTATE_IGNORE_STATE",
  "ATSTATE_IGNORE_ESC",
  "ATSTATE_IGNORE",
  "ATSTATE_BELL",
  "ATSTATE_BS",
  "ATSTATE_CR",
  "ATSTATE_ESC",
  "ATSTATE_VT",
  "ATSTATE_HT",
  "ATSTATE_SI",
  "ATSTATE_SO",
  "ATSTATE_SCR_STATE",
  "ATSTATE_SCS0_STATE",
  "ATSTATE_SCS1_STATE",
  "ATSTATE_SCS2_STATE",
  "ATSTATE_SCS3_STATE",
  "ATSTATE_ESC_IGNORE",
  "ATSTATE_ESC_DIGIT",
  "ATSTATE_ESC_SEMI",
  "ATSTATE_DEC_STATE (invalid)",
  "ATSTATE_ICH",
  "ATSTATE_CUU",
  "ATSTATE_CUD",
  "ATSTATE_CUF",
  "ATSTATE_CUB",
  "ATSTATE_CUP",
  "ATSTATE_ED",
  "ATSTATE_EL",
  "ATSTATE_IL",
  "ATSTATE_DL",
  "ATSTATE_DCH",
  "ATSTATE_DA1",
  "ATSTATE_TRACK_MOUSE",
  "ATSTATE_TBC",
  "ATSTATE_SET",
  "ATSTATE_RST",
  "ATSTATE_SGR",
  "ATSTATE_CPR",
  "ATSTATE_DECSTBM",
  "ATSTATE_DECREQTPARM",
  "ATSTATE_DECSET",
  "ATSTATE_DECRST",
  "ATSTATE_DECALN",
  "ATSTATE_GSETS",
  "ATSTATE_DECSC",
  "ATSTATE_DECRC",
  "ATSTATE_DECKPAM",
  "ATSTATE_DECKPNM",
  "ATSTATE_IND",
  "ATSTATE_NEL",
  "ATSTATE_HTS",
  "ATSTATE_RI",
  "ATSTATE_SS2",
  "ATSTATE_SS3",
  "ATSTATE_CSI_STATE",
  "ATSTATE_OSC",
  "ATSTATE_RIS",
  "ATSTATE_LS2",
  "ATSTATE_LS3",
  "ATSTATE_LS3R",
  "ATSTATE_LS2R",
  "ATSTATE_LS1R",
  "ATSTATE_PRINT",
  "ATSTATE_XTERM_SAVE",
  "ATSTATE_XTERM_RESTORE",
  "ATSTATE_XTERM_TITLE",
  "ATSTATE_DECID",
  "ATSTATE_SIMD",
  "ATSTATE_CSI_SIB",
  "ATSTATE_SLH",
  "ATSTATE_SLL",
  "ATSTATE_TSR",
  "ATSTATE_ECH",
  "ATSTATE_CBT",
  "ATSTATE_CHA",
  "ATSTATE_CHT",
  "ATSTATE_CNL",
  "ATSTATE_CPL",
  "ATSTATE_CTC",
  "ATSTATE_SD",
  "ATSTATE_SL",
  "ATSTATE_SR",
  "ATSTATE_SU",
  "ATSTATE_VPA",
  "ATSTATE_DEL",
  "??1",
  "??2",
  "??3",
  "??4",
  "??5",
  "??6",
  "??7",
  "??8",
  "??9"
};
