/* xterm (ansi/DEC emulation) states */
#define ATSTATE_GROUND_STATE 0
#define ATSTATE_IGNORE_STATE 1
#define ATSTATE_IGNORE_ESC   2
#define ATSTATE_IGNORE       3
#define ATSTATE_BELL         4
#define ATSTATE_BS           5
#define ATSTATE_CR           6
#define ATSTATE_ESC          7
#define ATSTATE_VT           8
#define ATSTATE_HT           9
#define ATSTATE_SI          10
#define ATSTATE_SO          11
#define ATSTATE_SCR_STATE   12
#define ATSTATE_SCS0_STATE  13
#define ATSTATE_SCS1_STATE  14
#define ATSTATE_SCS2_STATE  15
#define ATSTATE_SCS3_STATE  16
#define ATSTATE_ESC_IGNORE  17
#define ATSTATE_ESC_DIGIT   18
#define ATSTATE_ESC_SEMI    19
#define ATSTATE_ICH         21
#define ATSTATE_CUU         22
#define ATSTATE_CUD         23
#define ATSTATE_CUF         24
#define ATSTATE_CUB         25
#define ATSTATE_CUP         26
#define ATSTATE_ED          27
#define ATSTATE_EL          28
#define ATSTATE_IL          29
#define ATSTATE_DL          30
#define ATSTATE_DCH         31
#define ATSTATE_DA1         32
#define ATSTATE_TRACK_MOUSE 33
#define ATSTATE_TBC         34
#define ATSTATE_SET         35
#define ATSTATE_RST         36
#define ATSTATE_SGR         37
#define ATSTATE_CPR         38
#define ATSTATE_DECSTBM     39
#define ATSTATE_DECREQTPARM 40
#define ATSTATE_DECSET      41
#define ATSTATE_DECRST      42
#define ATSTATE_DECALN      43
#define ATSTATE_GSETS       44
#define ATSTATE_DECSC       45
#define ATSTATE_DECRC       46
#define ATSTATE_DECKPAM     47
#define ATSTATE_DECKPNM     48
#define ATSTATE_IND         49
#define ATSTATE_NEL         50
#define ATSTATE_HTS         51
#define ATSTATE_RI          52
#define ATSTATE_SS2         53
#define ATSTATE_SS3         54
#define ATSTATE_CSI_STATE   55
#define ATSTATE_OSC         56
#define ATSTATE_RIS         57
#define ATSTATE_LS2         58
#define ATSTATE_LS3         59
#define ATSTATE_LS3R        60
#define ATSTATE_LS2R        61
#define ATSTATE_LS1R        62
#define ATSTATE_PRINT       63
#define ATSTATE_XTERM_SAVE  64
#define ATSTATE_XTERM_RESTORE 65
#define ATSTATE_XTERM_TITLE 66
#define ATSTATE_DECID       67
#define ATSTATE_SIMD        68
#define ATSTATE_CSI_SIB     69
#define ATSTATE_SLH         70
#define ATSTATE_SLL         71
#define ATSTATE_TSR         72
#define ATSTATE_ECH         73
#define ATSTATE_CBT         74
#define ATSTATE_CHA         75
#define ATSTATE_CHT         76
#define ATSTATE_CNL         77
#define ATSTATE_CPL         78
#define ATSTATE_CTC         79
#define ATSTATE_SD          80
#define ATSTATE_SL          81
#define ATSTATE_SR          82
#define ATSTATE_SU          83
#define ATSTATE_VPA         84
#define ATSTATE_DEL         85

extern int  atGroundTable[];
extern int  atCSITable[];
extern int  atEIGTable[];
extern int  atESCTable[];
extern int  atIESTable[];
extern int  atIGNTable[];
extern int  atSCRTable[];
extern int  atSCSTable[];
extern int  atCSI_SIBTable[];
extern char *atStateTable[];

